//
// Created by lukas on 06.02.22.
//
#define GL_GLEXT_PROTOTYPES
#include <GL/gl.h>
#include "CrossHair.h"

VertexArray *CrossHair::setVertexArray() {
    float fade[] = {
            // face #1
            -0.02, -0.05,
            0.02, 0.02,
            -0.05, 0.05,
            };

    // Generate a vertex buffer
    auto *vb = new VertexBuffer(fade, sizeof(fade));
    auto *va = new VertexArray(*vb);
    va->add(0,2,3,0);

    return va;
}

Shader CrossHair::setShader() {
    const std::string vertsrc =
#include "vertex.shader"

    const std::string fragsrc =
#include "fragment.shader"

    Shader s;
    s.loadShader(vertsrc, "", fragsrc);
    s.Bind();

    return s;
}

IndexBuffer *CrossHair::setIndexBuffer() {
    unsigned indexx[] = {
            0,2,1
    };

    return new IndexBuffer(indexx, 3);
}

void CrossHair::render() {
    s.Bind();
    glUniform3f(getUniformhandle("u_color"), 1.0f, 1.0f, 1.0f);
    RenderBase::render();
}
